﻿Public Class ServiceManager

    Private Shared ReadOnly Instance As ServiceManager = New ServiceManager()
    Private Shared ReadOnly Services As Dictionary(Of Type, Object)

    Private Shared ReadOnly Lock As Object = New Object()

    Shared Sub New()
        Services = New Dictionary(Of Type, Object)()
        Lock = New Object()
    End Sub

    Public Shared Function GetInstance() As ServiceManager
        Return Instance
    End Function

    Public Shared Function GetService(Of TServiceContract As Class)() As TServiceContract
        Dim service As Object = Nothing
        SyncLock Lock
            Services.TryGetValue(GetType(TServiceContract), service)
        End SyncLock
        Return CType(service, TServiceContract)
    End Function

    Public Sub AddService(Of TServiceContract As Class)(implementation As TServiceContract)
        SyncLock Lock
            Services(GetType(TServiceContract)) = implementation
        End SyncLock
    End Sub

End Class
